Index: LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2258)
@@ -181,7 +181,13 @@
 !!!
        pplay,     paprs,     pctsrf,                  &
-       ts,        alb1, alb2,ustar, u10m, v10m,wstar, &
+!albedo SB >>>
+!       ts,        alb1, alb2,ustar, u10m, v10m,wstar, &
+       ts,SFRWL,   alb_dir, alb_dif,ustar, u10m, v10m,wstar, &
+!albedo SB <<<
        cdragh,    cdragm,   zu1,    zv1,              &
-       alb1_m,    alb2_m,    zxsens,   zxevap,        &
+!albedo SB >>>
+!       alb1_m,    alb2_m,    zxsens,   zxevap,        &
+       alb_dir_m,    alb_dif_m,  zxsens,   zxevap,    &
+!albedo SB <<<
        alb3_lic,  runoff,    snowhgt,   qsnow,     to_ice,    sissnow,  &
        zxtsol,    zxfluxlat, zt2m,     qsat2m,        &
@@ -349,6 +355,10 @@
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: delta_tsurf !surface temperature difference between
                                                                    !wake and off-wake regions
-    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb1    ! albedo in visible SW interval
-    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb2    ! albedo in near infra-red SW interval
+!albedo SB >>>
+!    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb1    ! albedo in visible SW interval
+!    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb2    ! albedo in near infra-red SW interval
+    REAL, DIMENSIOn(6),intent(in) :: SFRWL
+    REAL, DIMENSION(klon, nsw, nbsrf), INTENT(INOUT)     :: alb_dir,alb_dif
+!albedo SB <<<
 !jyg Pourquoi ustar et wstar sont-elles INOUT ?
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: ustar   ! u* (m/s)
@@ -371,6 +381,11 @@
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zu1        ! u wind speed in first layer
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zv1        ! v wind speed in first layer
-    REAL, DIMENSION(klon),        INTENT(OUT)       :: alb1_m     ! mean albedo in visible SW interval
-    REAL, DIMENSION(klon),        INTENT(OUT)       :: alb2_m     ! mean albedo in near IR SW interval
+!albedo SB >>>
+!    REAL, DIMENSION(klon),        INTENT(OUT)       :: alb1_m     ! mean albedo
+!    in visible SW interval
+!    REAL, DIMENSION(klon),        INTENT(OUT)       :: alb2_m     ! mean albedo
+!    in near IR SW interval
+    REAL, DIMENSION(klon, nsw),        INTENT(OUT)       :: alb_dir_m,alb_dif_m
+!albedo SB <<<
     ! Martin
     REAL, DIMENSION(klon),        INTENT(OUT)       :: alb3_lic
@@ -505,5 +520,8 @@
     REAL, DIMENSION(klon)              :: r_co2_ppm     ! taux CO2 atmosphere
     REAL, DIMENSION(klon)              :: yts, yrugos, ypct, yz0_new
-    REAL, DIMENSION(klon)              :: yalb, yalb1, yalb2
+!albedo SB >>>
+!   REAL, DIMENSION(klon)              :: yalb, yalb1, yalb2
+    REAL, DIMENSION(klon)              :: yalb,yalb_vis
+!albedo SB <<<
     REAL, DIMENSION(klon)              :: yu1, yv1
     REAL, DIMENSION(klon)              :: ysnow, yqsurf, yagesno, yqsol
@@ -535,5 +553,5 @@
     REAL, DIMENSION(klon)              :: tair1, qair1, tairsol
     REAL, DIMENSION(klon)              :: psfce, patm
-    REAL, DIMENSION(klon)              :: qairsol, zgeo1
+    REAL, DIMENSION(klon)              :: qairsol, zgeo1, speed, zri1, pref !speed, zri1, pref, added by Fuxing WANG, 04/03/2015
     REAL, DIMENSION(klon)              :: rugo1
     REAL, DIMENSION(klon)              :: yfluxsens
@@ -542,4 +560,7 @@
     REAL, DIMENSION(klon)              :: ypsref
     REAL, DIMENSION(klon)              :: yevap, ytsurf_new, yalb1_new, yalb2_new, yalb3_new
+!albedo SB >>>
+    REAL, DIMENSION(klon,nsw)          :: yalb_dir_new, yalb_dif_new
+!albedo SB <<<
     REAL, DIMENSION(klon)              :: ztsol
     REAL, DIMENSION(klon)              :: alb_m  ! mean albedo for whole SW interval
@@ -693,8 +714,8 @@
     REAL, DIMENSION(klon)       :: ytrmb3_w
 !
-    REAL, DIMENSION(klon)              :: uzon_x, vmer_x
+    REAL, DIMENSION(klon)              :: uzon_x, vmer_x, speed_x, zri1_x, pref_x !speed_x, zri1_x, pref_x, added by Fuxing WANG, 04/03/2015
     REAL, DIMENSION(klon)              :: zgeo1_x, tair1_x, qair1_x, tairsol_x
 !
-    REAL, DIMENSION(klon)              :: uzon_w, vmer_w
+    REAL, DIMENSION(klon)              :: uzon_w, vmer_w, speed_w, zri1_w, pref_w !speed_w, zri1_w, pref_w, added by Fuxing WANG, 04/03/2015
     REAL, DIMENSION(klon)              :: zgeo1_w, tair1_w, qair1_w, tairsol_w
 
@@ -855,5 +876,8 @@
  cdragh(:)=0. ; cdragm(:)=0.
  zu1(:)=0. ; zv1(:)=0.
- alb1_m(:)=0. ; alb2_m(:)=0. ; alb3_lic(:)=0.
+!albedo SB >>>
+! alb1_m(:)=0. ; alb2_m(:)=0. ; alb3_lic(:)=0.
+  alb_dir_m=0. ; alb_dif_m=0. ; alb3_lic(:)=0.
+!albedo SB <<<
  zxsens(:)=0. ; zxevap(:)=0. ; zxtsol(:)=0.
  d_t_w(:,:)=0. ; d_q_w(:,:)=0. ; d_t_x(:,:)=0. ; d_q_x(:,:)=0.
@@ -920,5 +944,8 @@
     ypct = 0.0    ; yts = 0.0        ; ysnow = 0.0
 !!    zv1 = 0.0     ; yqsurf = 0.0     ; yalb1 = 0.0     ; yalb2 = 0.0    
-    yqsurf = 0.0  ; yalb1 = 0.0      ; yalb2 = 0.0    
+!albedo SB >>>
+!    yqsurf = 0.0  ; yalb1 = 0.0      ; yalb2 = 0.0    
+    yqsurf = 0.0  ; yalb = 0.0 ; yalb_vis = 0.0
+!albedo SB <<<
     yrain_f = 0.0 ; ysnow_f = 0.0    ; yfder = 0.0     ; ysolsw = 0.0    
     ysollw = 0.0  ; yrugos = 0.0     ; yu1 = 0.0    
@@ -1070,27 +1097,60 @@
 ! * alb_m  : mean albedo at whole SW interval
 
-    alb1_m(:) = 0.0
-    alb2_m(:) = 0.0
-    DO nsrf = 1, nbsrf
+!albedo SB >>>
+!    alb1_m(:) = 0.0
+!    alb2_m(:) = 0.0
+!    DO nsrf = 1, nbsrf
+!       DO i = 1, klon
+!          alb1_m(i) = alb1_m(i) + alb1(i,nsrf) * pctsrf(i,nsrf)
+!          alb2_m(i) = alb2_m(i) + alb2(i,nsrf) * pctsrf(i,nsrf)
+!       ENDDO
+!    ENDDO
+
+    alb_dir_m(:,:) = 0.0
+    alb_dif_m(:,:) = 0.0
+    DO k = 1, nsw
+     DO nsrf = 1, nbsrf
        DO i = 1, klon
-          alb1_m(i) = alb1_m(i) + alb1(i,nsrf) * pctsrf(i,nsrf)
-          alb2_m(i) = alb2_m(i) + alb2(i,nsrf) * pctsrf(i,nsrf)
+          alb_dir_m(i,k) = alb_dir_m(i,k) + alb_dir(i,k,nsrf) * pctsrf(i,nsrf)
+          alb_dif_m(i,k) = alb_dif_m(i,k) + alb_dif(i,k,nsrf) * pctsrf(i,nsrf)
        ENDDO
+     ENDDO
     ENDDO
 
 ! We here suppose the fraction f1 of incoming radiance of visible radiance 
 ! as a fraction of all shortwave radiance 
-    f1 = 0.5 
+    f1 = 0.5
 !    f1 = 1    ! put f1=1 to recreate old calculations
 
-    DO nsrf = 1, nbsrf
-       DO i = 1, klon
-          alb(i,nsrf) = f1*alb1(i,nsrf) + (1-f1)*alb2(i,nsrf)
-       ENDDO
+!    DO nsrf = 1, nbsrf
+!       DO i = 1, klon
+!          alb(i,nsrf) = f1*alb1(i,nsrf) + (1-f1)*alb2(i,nsrf)
+!       ENDDO
+!    ENDDO
+!
+!    DO i = 1, klon
+!       alb_m(i) = f1*alb1_m(i) + (1-f1)*alb2_m(i)
+!    END DO
+
+
+!f1 is already included with SFRWL values in each surf files
+    alb=0.0
+    DO k=1,nsw
+      DO nsrf = 1, nbsrf
+        DO i = 1, klon
+            alb(i,nsrf) = alb(i,nsrf) + alb_dir(i,k,nsrf)*SFRWL(k)
+        ENDDO
+      ENDDO
     ENDDO
 
-    DO i = 1, klon
-       alb_m(i) = f1*alb1_m(i) + (1-f1)*alb2_m(i)
-    END DO
+    alb_m=0.0
+    DO k = 1,nsw
+      DO i = 1, klon
+        alb_m(i) = alb_m(i) + alb_dir_m(i,k)*SFRWL(k)
+      END DO
+    ENDDO
+!albedo SB <<<
+
+
 
 ! Calculation of mean temperature at surface grid points
@@ -1170,6 +1230,13 @@
           yqsurf(j)  = qsurf(i,nsrf)
           yalb(j)    = alb(i,nsrf)
-          yalb1(j)   = alb1(i,nsrf)
-          yalb2(j)   = alb2(i,nsrf)
+!albedo SB >>>
+!         yalb1(j)   = alb1(i,nsrf)
+!         yalb2(j)   = alb2(i,nsrf)
+          yalb_vis(j) = alb_dir(i,1,nsrf)
+          if(nsw==6)then
+            yalb_vis(j)=(alb_dir(i,1,nsrf)*SFRWL(1)+alb_dir(i,2,nsrf)*SFRWL(2) &
+              +alb_dir(i,3,nsrf)*SFRWL(3))/(SFRWL(1)+SFRWL(2)+SFRWL(3))
+          endif
+!albedo SB <<<
           yrain_f(j) = rain_f(i)
           ysnow_f(j) = snow_f(i)
@@ -1295,8 +1362,22 @@
 !!!
 !!! nrlmd & jyg les 02/05/2011, 13/06/2011, 05/02/2012
-        CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
-            yu(:,1), yv(:,1), yt(:,1), yq(:,1), &
+! Faire disparaitre les lignes commentees fin 2015 (le temps des tests)
+!       CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
+!           yu(:,1), yv(:,1), yt(:,1), yq(:,1), &
+!           yts, yqsurf, yrugos, &
+!           ycdragm, ycdragh )
+! Fuxing WANG, 04/03/2015, replace the clcdrag by the merged version: cdrag
+        DO i = 1, knon
+!          print*,'PBL ',i,RD
+!          print*,'PBL ',yt(i,1),ypaprs(i,1),ypplay(i,1)
+           zgeo1(i) = RD * yt(i,1) / (0.5*(ypaprs(i,1)+ypplay(i,1))) &
+                * (ypaprs(i,1)-ypplay(i,1))
+           speed(i) = SQRT(yu(i,1)**2+yv(i,1)**2)
+        END DO
+        CALL cdrag(knon, nsrf, &
+            speed, yt(:,1), yq(:,1), zgeo1, ypaprs(:,1),&
             yts, yqsurf, yrugos, &
-            ycdragm, ycdragh )
+            ycdragm, ycdragh, zri1, pref )
+
 ! --- special Dice: on force cdragm ( a defaut de forcer ustar) MPL 05082013
      IF (ok_prescr_ust) then
@@ -1313,8 +1394,21 @@
         IF (prt_level >=10) print *,'clcdrag -> ycdragh ', ycdragh
        ELSE  !(iflag_split .eq.0)
-        CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
-            yu_x(:,1), yv_x(:,1), yt_x(:,1), yq_x(:,1), &
+
+! Faire disparaitre les lignes commentees fin 2015 (le temps des tests)
+!       CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
+!           yu_x(:,1), yv_x(:,1), yt_x(:,1), yq_x(:,1), &
+!           yts_x, yqsurf, yrugos, &
+!           ycdragm_x, ycdragh_x )
+! Fuxing WANG, 04/03/2015, replace the clcdrag by the merged version: cdrag
+        DO i = 1, knon
+           zgeo1_x(i) = RD * yt_x(i,1) / (0.5*(ypaprs(i,1)+ypplay(i,1))) &
+                * (ypaprs(i,1)-ypplay(i,1))
+           speed_x(i) = SQRT(yu_x(i,1)**2+yv_x(i,1)**2)
+        END DO
+        CALL cdrag(knon, nsrf, &
+            speed_x, yt_x(:,1), yq_x(:,1), zgeo1_x, ypaprs(:,1),&
             yts_x, yqsurf, yrugos, &
-            ycdragm_x, ycdragh_x )
+            ycdragm_x, ycdragh_x, zri1_x, pref_x )
+
 ! --- special Dice. JYG+MPL 25112013
         IF (ok_prescr_ust) then
@@ -1710,5 +1804,8 @@
                ylwdown, yq2m, yt2m, &
                ysnow, yqsol, yagesno, ytsoil, &
-               yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
+!albedo SB >>>
+!              yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
+               yz0_new, SFRWL, yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
+!albedo SB <<<
                yqsurf, ytsurf_new, y_dflux_t, y_dflux_q, &
                y_flux_u1, y_flux_v1 )
@@ -1746,5 +1843,8 @@
                ypsref, yu1, yv1, yrugoro, pctsrf, &
                ysnow, yqsurf, yqsol, yagesno, &
-               ytsoil, yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
+!albedo SB >>>
+!              ytsoil, yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
+               ytsoil, yz0_new, SFRWL, yalb_dir_new, yalb_dif_new, yevap,yfluxsens,yfluxlat, &
+!albedo SB <<<
                ytsurf_new, y_dflux_t, y_dflux_q, &
                yzsig, ycldt, &
@@ -1778,5 +1878,8 @@
           
        CASE(is_oce)
-          CALL surf_ocean(rlon, rlat, ysolsw, ysollw, yalb1, &
+!albedo SB >>>
+!          CALL surf_ocean(rlon, rlat, ysolsw, ysollw, yalb1, &
+           CALL surf_ocean(rlon, rlat, ysolsw, ysollw, yalb_vis, &
+!albedo SB <<<
                yrugos, ywindsp, rmu0, yfder, yts, &
                itap, dtime, jour, knon, ni, &
@@ -1786,5 +1889,8 @@
                ypsref, yu1, yv1, yrugoro, pctsrf, &
                ysnow, yqsurf, yagesno, &
-               yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
+!albedo SB >>>
+!              yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
+               yz0_new, SFRWL,yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
+!albedo SB <<<
                ytsurf_new, y_dflux_t, y_dflux_q, slab_wfbils, &
                y_flux_u1, y_flux_v1)
@@ -1807,5 +1913,8 @@
        CASE(is_sic)
           CALL surf_seaice( &
-               rlon, rlat, ysolsw, ysollw, yalb1, yfder, &
+!albedo SB >>>
+!               rlon, rlat, ysolsw, ysollw, yalb1, yfder, &
+               rlon, rlat, ysolsw, ysollw, yalb_vis, yfder, &
+!albedo SB <<<
                itap, dtime, jour, knon, ni, &
                lafin, &
@@ -1815,5 +1924,8 @@
                ypsref, yu1, yv1, yrugoro, pctsrf, &
                ysnow, yqsurf, yqsol, yagesno, ytsoil, &
-               yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
+!albedo SB >>>
+!               yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
+               yz0_new, SFRWL, yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
+!albedo SB <<<
                ytsurf_new, y_dflux_t, y_dflux_q, &
                y_flux_u1, y_flux_v1)
@@ -2185,6 +2297,12 @@
           evap(i,nsrf) = - flux_q(i,1,nsrf)                  !jyg
           d_ts(i,nsrf) = y_d_ts(j)
-          alb1(i,nsrf) = yalb1_new(j)  
-          alb2(i,nsrf) = yalb2_new(j)
+!albedo SB >>>
+!          alb1(i,nsrf) = yalb1_new(j)  
+!          alb2(i,nsrf) = yalb2_new(j)
+          do k=1,nsw
+          alb_dir(i,k,nsrf) = yalb_dir_new(j,k)
+          alb_dif(i,k,nsrf) = yalb_dif_new(j,k)
+          enddo
+!albedo SB <<<
           snow(i,nsrf) = ysnow(j)  
           qsurf(i,nsrf) = yqsurf(j)
@@ -2930,6 +3048,9 @@
 !****************************************************************************************
 ! 
-  SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, tsurf, alb1, alb2, ustar, u10m, v10m, tke)
-
+
+!albedo SB >>>
+!  SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, tsurf, alb1, alb2, ustar, u10m, v10m, tke)
+SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, tsurf,alb_dir,alb_dif, ustar, u10m, v10m, tke)  
+!albedo SB <<<
     ! Give default values where new fraction has appread
 
@@ -2948,5 +3069,9 @@
 !****************************************************************************************
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: tsurf
-    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: alb1, alb2
+!albedo SB >>>
+!   REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: alb1, alb2
+    REAL, DIMENSION(klon,nsw,nbsrf), INTENT(INOUT)       :: alb_dir, alb_dif 
+    INTEGER :: k
+!albedo SB <<<
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: ustar,u10m, v10m
     REAL, DIMENSION(klon,klev+1,nbsrf+1), INTENT(INOUT) :: tke
@@ -2993,6 +3118,12 @@
                 rugos(i,nsrf) = rugos(i,nsrf_comp1)
                 tsurf(i,nsrf) = tsurf(i,nsrf_comp1)
-                alb1(i,nsrf)  = alb1(i,nsrf_comp1)
-                alb2(i,nsrf)  = alb2(i,nsrf_comp1)
+!albedo SB >>>
+!                alb1(i,nsrf)  = alb1(i,nsrf_comp1)
+!                alb2(i,nsrf)  = alb2(i,nsrf_comp1)
+                DO k=1,nsw
+                 alb_dir(i,k,nsrf)=alb_dir(i,k,nsrf_comp1)
+                 alb_dif(i,k,nsrf)=alb_dif(i,k,nsrf_comp1)
+                ENDDO
+!albedo SB <<<
                 ustar(i,nsrf)  = ustar(i,nsrf_comp1)
                 u10m(i,nsrf)  = u10m(i,nsrf_comp1)
@@ -3008,6 +3139,14 @@
                 rugos(i,nsrf) = rugos(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + rugos(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
                 tsurf(i,nsrf) = tsurf(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + tsurf(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
-                alb1(i,nsrf)  = alb1(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + alb1(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
-                alb2(i,nsrf)  = alb2(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + alb2(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
+!albedo SB >>>
+!                alb1(i,nsrf)  = alb1(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + alb1(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
+!                alb2(i,nsrf)  = alb2(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + alb2(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
+                DO k=1,nsw
+                 alb_dir(i,k,nsrf)=alb_dir(i,k,nsrf_comp2)*pctsrf_old(i,nsrf_comp2)+&
+                                        alb_dir(i,k,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
+                 alb_dif(i,k,nsrf)=alb_dif(i,k,nsrf_comp2)*pctsrf_old(i,nsrf_comp2)+&
+                                        alb_dif(i,k,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
+                ENDDO
+!albedo SB <<<
                 ustar(i,nsrf)  = ustar(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + ustar(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
                 u10m(i,nsrf)  = u10m(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + u10m(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
Index: LMDZ5/branches/testing/libf/phylmd/phyetat0.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2258)
@@ -11,4 +11,5 @@
   USE phys_state_var_mod, ONLY : ancien_ok, clwcon, detr_therm, dtime, &
        du_gwd_rando, dv_gwd_rando, entr_therm, f0, falb1, falb2, fm_therm, &
+       falb_dir, falb_dif, &
        ftsol, pbl_tke, pctsrf, q_ancien, radpas, radsol, rain_fall, ratqs, &
        rlat, rlon, rnebcon, rugoro, sig1, snow_fall, solaire_etat0, sollw, sollwdown, &
@@ -69,5 +70,5 @@
   INTEGER length
   PARAMETER (length=100)
-  INTEGER it, iiq
+  INTEGER it, iiq, isw
   REAL tab_cntrl(length), tabcntr0(length)
   CHARACTER*7 str7
@@ -243,4 +244,35 @@
   ENDIF
 
+!===================================================================
+  ! Lecture des albedo difus et direct
+
+  DO nsrf = 1, nbsrf
+     DO isw=1, nsw
+        IF (isw.GT.99 .AND. nsrf.GT.99) THEN
+           PRINT*, "Trop de bandes SW ou sous-mailles"
+           call abort_gcm("phyetat0", "", 1)
+        ENDIF
+        WRITE(str7, '(i2.2, "srf", i2.2)') isw, nsrf
+
+        CALL get_field('A_dir_SW'//str7, falb_dir(:, isw, nsrf), found)
+        IF (.NOT. found) THEN
+           PRINT*, "phyetat0: Le champ <A_dir_SW"//str7//"> est absent"
+           PRINT*, "          Il prend donc la valeur de surface"
+           DO i=1, klon
+              falb_dir(i, isw, nsrf)=0.2
+           ENDDO
+        ENDIF
+        CALL get_field('A_dif_SW'//str7, falb_dif(:, isw, nsrf), found)
+        IF (.NOT. found) THEN
+           PRINT*, "phyetat0: Le champ <A_dif_SW"//str7//"> est absent"
+           PRINT*, "          Il prend donc la valeur de surface"
+           DO i=1, klon
+              falb_dif(i, isw, nsrf)=0.2
+           ENDDO
+        ENDIF
+     ENDDO
+  ENDDO
+
+!===================================================================
   ! Lecture des temperatures du sol profond:
 
@@ -264,4 +296,5 @@
   ENDDO
 
+!===================================================================
   ! Lecture de l'humidite de l'air juste au dessus du sol:
 
Index: LMDZ5/branches/testing/libf/phylmd/phyredem.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2258)
@@ -51,5 +51,5 @@
   REAL tab_cntrl(length)
 
-  INTEGER isoil, nsrf
+  INTEGER isoil, nsrf,isw
   CHARACTER (len=7) :: str7
   CHARACTER (len=2) :: str2
@@ -142,4 +142,23 @@
   ENDDO
 
+! ================== Albedo =======================================
+  print*,'PHYREDEM NOUVEAU'
+  DO nsrf = 1, nbsrf
+     DO isw=1, nsw
+        IF (isw.LE.99 .AND. nsrf.LE.99) THEN
+           WRITE(str7, '(i2.2, "srf", i2.2)') isw, nsrf
+  print*,'PHYREDEM ',"A_dir_SW"//str7
+           CALL put_field("A_dir_SW"//str7, "Albedo direct du sol bande "//str7, &
+                falb_dir(:, isw, nsrf))
+           CALL put_field("A_dif_SW"//str7, "Albedo difus du sol bande "//str7, &
+                falb_dif(:, isw, nsrf))
+        ELSE
+           PRINT*, "Trop de couches"
+           call abort_gcm("phyredem", "", 1)
+        ENDIF
+     ENDDO
+  ENDDO
+
+! ================== Tsoil =======================================
   DO nsrf = 1, nbsrf
      DO isoil=1, nsoilmx
Index: LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2220)
+++ LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2258)
@@ -30,4 +30,12 @@
       REAL, ALLOCATABLE, SAVE :: falb1(:,:), falb2(:,:)
 !$OMP THREADPRIVATE(falb1, falb2)
+
+!albedo SB >>>
+      REAL, ALLOCATABLE, SAVE :: falb_dif(:,:,:), falb_dir(:,:,:)
+      real, allocatable, save :: chl_con(:)
+!$OMP THREADPRIVATE(falb_dir,falb_dif,chl_con)
+!albedo SB <<<
+
+
       REAL, ALLOCATABLE, SAVE :: rain_fall(:), snow_fall(:)
 !$OMP THREADPRIVATE( rain_fall, snow_fall)
@@ -261,4 +269,10 @@
 !$OMP THREADPRIVATE(albsol1,albsol2)
 
+!albedo SB >>>
+      REAL,ALLOCATABLE,SAVE :: albsol_dif(:,:),albsol_dir(:,:)
+!$OMP THREADPRIVATE(albsol_dif,albsol_dir)
+!albedo SB <<<
+
+
       REAL, ALLOCATABLE, SAVE:: wo(:, :, :)
       ! column-density of ozone in a layer, in kilo-Dobsons
@@ -404,4 +418,8 @@
       ALLOCATE(falb1(klon,nbsrf))
       ALLOCATE(falb2(klon,nbsrf))
+!albedo SB >>> 
+      ALLOCATE(falb_dir(klon,nsw,nbsrf),falb_dif(klon,nsw,nbsrf))
+      ALLOCATE(chl_con(klon))
+!albedo SB <<<
       ALLOCATE(rain_fall(klon))
       ALLOCATE(snow_fall(klon))
@@ -501,4 +519,7 @@
       ALLOCATE(paire_ter(klon))
       ALLOCATE(albsol1(klon), albsol2(klon))
+!albedo SB >>>
+      ALLOCATE(albsol_dir(klon,nsw),albsol_dif(klon,nsw))
+!albedo SB <<<
 
       if (read_climoz <= 1) then
@@ -634,4 +655,7 @@
       deallocate(paire_ter)
       deallocate(albsol1, albsol2)
+!albedo SB >>>
+      deallocate(albsol_dir,albsol_dif,falb_dir,falb_dif,chl_con)
+!albedo SB <<<
       deallocate(wo)
       deallocate(clwcon0,rnebcon0)
